searchData={"items":[{"type":"module","title":"Shifts","doc":"![License](https://img.shields.io/github/license/lebrunel/shifts?color=informational)\n\nShifts is a framework for composing autonomous **agent** workflows, using a\nmixture of LLM backends.\n\n- 🤖 **Automate your chores** - have AI agents handle the mundane so you can focus on the things you care about.\n- 💪🏻 **Agents with superpowers** - create tools, so your agents can interact with the Web or internal APIs and systems.\n- 🧩 **Flexible and adaptable** - easily compose and modify workflows to suit your specific needs.\n- 🤗 **Delightful simplicity** - pipe instructions together using just plain English and intuitive APIs.\n- 🎨 **Mix and match** - Plug into different LLMs even within the same workflow so you are always using the right tool for job.","ref":"Shifts.html"},{"type":"module","title":"Current dev status - Shifts","doc":"| Version   | Stability                                                  | Status              |\n| --------- | -----------------------------------------------------------| ------------------- |\n| `0.0.x`   | For the brave and adventurous - expect breaking changes.   | **👈🏻 We are here!**  |\n| `0.x.0`   | Focus on better docs with less frequent breaking changes.  |                     |\n| `1.0.0` + | 🚀 Launched. Great docs, great dev experience, stable APIs. |                     |","ref":"Shifts.html#module-current-dev-status"},{"type":"module","title":"Currently supported LLMs - Shifts","doc":"- Anthropic / Claude 3 - **Recommended**\n- Ollama - Hermes Pro","ref":"Shifts.html#module-currently-supported-llms"},{"type":"module","title":"Installation - Shifts","doc":"The package can be installed by adding `shifts` to your list of dependencies\nin `mix.exs`.\n\n```elixir\ndef deps do\n  [\n    {:shifts, \"~> 0.0.1\"}\n  ]\nend\n```\n\nDocumentation to follow...","ref":"Shifts.html#module-installation"},{"type":"function","title":"Shifts.process/2","doc":"TODO","ref":"Shifts.html#process/2"},{"type":"module","title":"Shifts.Chat","doc":"TODO","ref":"Shifts.Chat.html"},{"type":"function","title":"Shifts.Chat.add_message/2","doc":"TODO","ref":"Shifts.Chat.html#add_message/2"},{"type":"function","title":"Shifts.Chat.add_message/3","doc":"TODO","ref":"Shifts.Chat.html#add_message/3"},{"type":"function","title":"Shifts.Chat.finalize/1","doc":"TODO","ref":"Shifts.Chat.html#finalize/1"},{"type":"function","title":"Shifts.Chat.generate_next_message/1","doc":"TODO","ref":"Shifts.Chat.html#generate_next_message/1"},{"type":"function","title":"Shifts.Chat.handle_tool_use/2","doc":"TODO","ref":"Shifts.Chat.html#handle_tool_use/2"},{"type":"function","title":"Shifts.Chat.init/1","doc":"TODO","ref":"Shifts.Chat.html#init/1"},{"type":"function","title":"Shifts.Chat.put_system/2","doc":"TODO","ref":"Shifts.Chat.html#put_system/2"},{"type":"function","title":"Shifts.Chat.put_tools/2","doc":"","ref":"Shifts.Chat.html#put_tools/2"},{"type":"type","title":"Shifts.Chat.t/0","doc":"TODO","ref":"Shifts.Chat.html#t:t/0"},{"type":"module","title":"Shifts.ChatResult","doc":"TODO","ref":"Shifts.ChatResult.html"},{"type":"type","title":"Shifts.ChatResult.t/0","doc":"TODO","ref":"Shifts.ChatResult.html#t:t/0"},{"type":"module","title":"Shifts.Chore","doc":"TODO","ref":"Shifts.Chore.html"},{"type":"function","title":"Shifts.Chore.execute/2","doc":"TODO","ref":"Shifts.Chore.html#execute/2"},{"type":"function","title":"Shifts.Chore.new/1","doc":"TODO","ref":"Shifts.Chore.html#new/1"},{"type":"function","title":"Shifts.Chore.to_prompt/2","doc":"TODO","ref":"Shifts.Chore.html#to_prompt/2"},{"type":"type","title":"Shifts.Chore.t/0","doc":"TODO","ref":"Shifts.Chore.html#t:t/0"},{"type":"module","title":"Shifts.Config","doc":"","ref":"Shifts.Config.html"},{"type":"function","title":"Shifts.Config.get/2","doc":"","ref":"Shifts.Config.html#get/2"},{"type":"function","title":"Shifts.Config.get_all/0","doc":"","ref":"Shifts.Config.html#get_all/0"},{"type":"type","title":"Shifts.Config.t/0","doc":"","ref":"Shifts.Config.html#t:t/0"},{"type":"behaviour","title":"Shifts.LLM","doc":"TODO","ref":"Shifts.LLM.html"},{"type":"callback","title":"Shifts.LLM.generate_next_message/1","doc":"TODO","ref":"Shifts.LLM.html#c:generate_next_message/1"},{"type":"callback","title":"Shifts.LLM.get_message/1","doc":"TODO","ref":"Shifts.LLM.html#c:get_message/1"},{"type":"callback","title":"Shifts.LLM.get_metrics/1","doc":"TODO","ref":"Shifts.LLM.html#c:get_metrics/1"},{"type":"type","title":"Shifts.LLM.adapter/0","doc":"TODO","ref":"Shifts.LLM.html#t:adapter/0"},{"type":"type","title":"Shifts.LLM.response/0","doc":"TODO","ref":"Shifts.LLM.html#t:response/0"},{"type":"module","title":"Shifts.Message","doc":"TODO","ref":"Shifts.Message.html"},{"type":"function","title":"Shifts.Message.new/1","doc":"TODO","ref":"Shifts.Message.html#new/1"},{"type":"function","title":"Shifts.Message.put_record/2","doc":"TODO","ref":"Shifts.Message.html#put_record/2"},{"type":"type","title":"Shifts.Message.role/0","doc":"","ref":"Shifts.Message.html#t:role/0"},{"type":"type","title":"Shifts.Message.t/0","doc":"","ref":"Shifts.Message.html#t:t/0"},{"type":"behaviour","title":"Shifts.Shift","doc":"TODO","ref":"Shifts.Shift.html"},{"type":"function","title":"Shifts.Shift.chore/4","doc":"TODO","ref":"Shifts.Shift.html#chore/4"},{"type":"function","title":"Shifts.Shift.each/4","doc":"TODO","ref":"Shifts.Shift.html#each/4"},{"type":"macro","title":"Shifts.Shift.is_chore_input/1","doc":"","ref":"Shifts.Shift.html#is_chore_input/1"},{"type":"callback","title":"Shifts.Shift.work/2","doc":"TODO","ref":"Shifts.Shift.html#c:work/2"},{"type":"type","title":"Shifts.Shift.chore_input/0","doc":"","ref":"Shifts.Shift.html#t:chore_input/0"},{"type":"type","title":"Shifts.Shift.operation/0","doc":"","ref":"Shifts.Shift.html#t:operation/0"},{"type":"type","title":"Shifts.Shift.operation_name/0","doc":"","ref":"Shifts.Shift.html#t:operation_name/0"},{"type":"type","title":"Shifts.Shift.t/0","doc":"TODO","ref":"Shifts.Shift.html#t:t/0"},{"type":"module","title":"Shifts.ShiftResult","doc":"TODO","ref":"Shifts.ShiftResult.html"},{"type":"function","title":"Shifts.ShiftResult.to_outputs/1","doc":"TODO","ref":"Shifts.ShiftResult.html#to_outputs/1"},{"type":"type","title":"Shifts.ShiftResult.outputs/0","doc":"","ref":"Shifts.ShiftResult.html#t:outputs/0"},{"type":"type","title":"Shifts.ShiftResult.t/0","doc":"TODO","ref":"Shifts.ShiftResult.html#t:t/0"},{"type":"behaviour","title":"Shifts.Tool","doc":"TODO","ref":"Shifts.Tool.html"},{"type":"callback","title":"Shifts.Tool.call/2","doc":"Invoked when the tool is called, and must return a `String.t()` value.\n\nReceives the context `t:Shifts.Shift.t/0` and a map of arguments.","ref":"Shifts.Tool.html#c:call/2"},{"type":"macro","title":"Shifts.Tool.description/1","doc":"Sets the tool description.","ref":"Shifts.Tool.html#description/1"},{"type":"macro","title":"Shifts.Tool.name/1","doc":"Sets the tool name.","ref":"Shifts.Tool.html#name/1"},{"type":"function","title":"Shifts.Tool.new/1","doc":"Creates a new `t:Shifts.Tool.t/0` struct from the given options.","ref":"Shifts.Tool.html#new/1"},{"type":"macro","title":"Shifts.Tool.param/3","doc":"Sets a tool parameter.","ref":"Shifts.Tool.html#param/3"},{"type":"macro","title":"Shifts.Tool.tool_result/1","doc":"","ref":"Shifts.Tool.html#tool_result/1"},{"type":"macro","title":"Shifts.Tool.tool_result/2","doc":"","ref":"Shifts.Tool.html#tool_result/2"},{"type":"macro","title":"Shifts.Tool.tool_use/1","doc":"","ref":"Shifts.Tool.html#tool_use/1"},{"type":"macro","title":"Shifts.Tool.tool_use/2","doc":"","ref":"Shifts.Tool.html#tool_use/2"},{"type":"function","title":"Shifts.Tool.validate_mod/1","doc":"TODO","ref":"Shifts.Tool.html#validate_mod/1"},{"type":"type","title":"Shifts.Tool.args/0","doc":"","ref":"Shifts.Tool.html#t:args/0"},{"type":"type","title":"Shifts.Tool.param/0","doc":"","ref":"Shifts.Tool.html#t:param/0"},{"type":"type","title":"Shifts.Tool.param_type/0","doc":"","ref":"Shifts.Tool.html#t:param_type/0"},{"type":"type","title":"Shifts.Tool.t/0","doc":"TODO","ref":"Shifts.Tool.html#t:t/0"},{"type":"type","title":"Shifts.Tool.tool_call/0","doc":"","ref":"Shifts.Tool.html#t:tool_call/0"},{"type":"type","title":"Shifts.Tool.tool_record/0","doc":"","ref":"Shifts.Tool.html#t:tool_record/0"},{"type":"type","title":"Shifts.Tool.tool_result/0","doc":"","ref":"Shifts.Tool.html#t:tool_result/0"},{"type":"module","title":"Shifts.LLM.Anthropic","doc":"Anthropic adapter. Implements `Shifts.LLM`.","ref":"Shifts.LLM.Anthropic.html"},{"type":"module","title":"Shifts.LLM.OllamaHermesPro","doc":"Ollama Hermes Pro adapter. Implements `Shifts.LLM`.","ref":"Shifts.LLM.OllamaHermesPro.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,48]}}